/*
  Identification of servers the Helix Web Services instance can connect to.

*/
function P4dConfigId(data) {

    Object.defineProperties(this, {
        /*
          A simple string identifier (alphanumeric characters only, please)
        */
        "id": {
            value: data ? data.id : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A display string, not guaranteed to be unique
        */
        "name": {
            value: data ? data.name : undefined,
            enumerable: true,
            writable: true
        },
        /*
          A simple textual description, for potential selection by clients.
        */
        "description": {
            value: data ? data.description : undefined,
            enumerable: true,
            writable: true
        }
    });

}

module.exports = P4dConfigId;
