<?php
/**
 * GitFusionRepoConfig
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * GitFusionRepoConfig Class Doc Comment
 *
 * @category    Class
 * @description 
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class GitFusionRepoConfig implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'name' => 'string',
        'description' => 'string',
        'global_overrides' => '\HelixWebServices\Model\GitFusionRepoGlobalOverrides',
        'branches' => '\HelixWebServices\Model\GitFusionRepoBranchConfig[]'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'name' => 'name',
        'description' => 'description',
        'global_overrides' => 'globalOverrides',
        'branches' => 'branches'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'name' => 'setName',
        'description' => 'setDescription',
        'global_overrides' => 'setGlobalOverrides',
        'branches' => 'setBranches'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'name' => 'getName',
        'description' => 'getDescription',
        'global_overrides' => 'getGlobalOverrides',
        'branches' => 'getBranches'
    );

    
    /**
      * $name The repository name, which can be path-like.
      * @var string
      */
    protected $name;
    
    /**
      * $description Repo description returned by the @list command.
      * @var string
      */
    protected $description;
    
    /**
      * $global_overrides 
      * @var \HelixWebServices\Model\GitFusionRepoGlobalOverrides
      */
    protected $global_overrides;
    
    /**
      * $branches 
      * @var \HelixWebServices\Model\GitFusionRepoBranchConfig[]
      */
    protected $branches;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["name"])) {
              $this->name = $data["name"];
            }
            if (isset($data["description"])) {
              $this->description = $data["description"];
            }
            if (isset($data["global_overrides"])) {
              $this->global_overrides = $data["global_overrides"];
            }
            if (isset($data["branches"])) {
              $this->branches = $data["branches"];
            }
        }
    }
    
    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Sets name
     * @param string $name The repository name, which can be path-like.
     * @return $this
     */
    public function setName($name)
    {
        
        $this->name = $name;
        return $this;
    }
    
    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Sets description
     * @param string $description Repo description returned by the @list command.
     * @return $this
     */
    public function setDescription($description)
    {
        
        $this->description = $description;
        return $this;
    }
    
    /**
     * Gets global_overrides
     * @return \HelixWebServices\Model\GitFusionRepoGlobalOverrides
     */
    public function getGlobalOverrides()
    {
        return $this->global_overrides;
    }

    /**
     * Sets global_overrides
     * @param \HelixWebServices\Model\GitFusionRepoGlobalOverrides $global_overrides 
     * @return $this
     */
    public function setGlobalOverrides($global_overrides)
    {
        
        $this->global_overrides = $global_overrides;
        return $this;
    }
    
    /**
     * Gets branches
     * @return \HelixWebServices\Model\GitFusionRepoBranchConfig[]
     */
    public function getBranches()
    {
        return $this->branches;
    }

    /**
     * Sets branches
     * @param \HelixWebServices\Model\GitFusionRepoBranchConfig[] $branches 
     * @return $this
     */
    public function setBranches($branches)
    {
        
        $this->branches = $branches;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
