<?php
/**
 * GitFusionRepoGlobalOverrides
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * GitFusionRepoGlobalOverrides Class Doc Comment
 *
 * @category    Class
 * @description A list of per-repo settings that override global settings.
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class GitFusionRepoGlobalOverrides implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'charset' => 'string',
        'depot_path_repo_creation_enable' => 'string',
        'depot_path_repo_creation_p4group' => 'string',
        'change_owner' => 'string',
        'enable_git_branch_creation' => 'string',
        'enable_swarm_reviews' => 'string',
        'enable_git_merge_commits' => 'string',
        'enable_git_submodules' => 'string',
        'ignore_author_permissions' => 'string',
        'preflight_commit' => 'string',
        'read_permission_check' => 'string',
        'git_merge_avoidance_after_change_num' => 'string',
        'job_lookup' => 'string',
        'depot_branch_creation_enable' => 'string',
        'depot_branch_creation_p4group' => 'string',
        'depot_branch_creation_depot_path' => 'string',
        'depot_branch_creation_view' => 'string',
        'enable_git_find_copies' => 'string',
        'enable_git_find_renames' => 'string',
        'enable_stream_imports' => 'string',
        'http_url' => 'string',
        'ssh_url' => 'string',
        'email_case_sensitivity' => 'string',
        'author_source' => 'string',
        'limit_space_mb' => 'string',
        'limit_commits_received' => 'string',
        'limit_files_received' => 'string',
        'limit_megabytes_received' => 'string'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'charset' => 'charset',
        'depot_path_repo_creation_enable' => 'depotPathRepoCreationEnable',
        'depot_path_repo_creation_p4group' => 'depotPathRepoCreationP4group',
        'change_owner' => 'changeOwner',
        'enable_git_branch_creation' => 'enableGitBranchCreation',
        'enable_swarm_reviews' => 'enableSwarmReviews',
        'enable_git_merge_commits' => 'enableGitMergeCommits',
        'enable_git_submodules' => 'enableGitSubmodules',
        'ignore_author_permissions' => 'ignoreAuthorPermissions',
        'preflight_commit' => 'preflightCommit',
        'read_permission_check' => 'readPermissionCheck',
        'git_merge_avoidance_after_change_num' => 'gitMergeAvoidanceAfterChangeNum',
        'job_lookup' => 'jobLookup',
        'depot_branch_creation_enable' => 'depotBranchCreationEnable',
        'depot_branch_creation_p4group' => 'depotBranchCreationP4group',
        'depot_branch_creation_depot_path' => 'depotBranchCreationDepotPath',
        'depot_branch_creation_view' => 'depotBranchCreationView',
        'enable_git_find_copies' => 'enableGitFindCopies',
        'enable_git_find_renames' => 'enableGitFindRenames',
        'enable_stream_imports' => 'enableStreamImports',
        'http_url' => 'httpUrl',
        'ssh_url' => 'sshUrl',
        'email_case_sensitivity' => 'emailCaseSensitivity',
        'author_source' => 'authorSource',
        'limit_space_mb' => 'limitSpaceMb',
        'limit_commits_received' => 'limitCommitsReceived',
        'limit_files_received' => 'limitFilesReceived',
        'limit_megabytes_received' => 'limitMegabytesReceived'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'charset' => 'setCharset',
        'depot_path_repo_creation_enable' => 'setDepotPathRepoCreationEnable',
        'depot_path_repo_creation_p4group' => 'setDepotPathRepoCreationP4group',
        'change_owner' => 'setChangeOwner',
        'enable_git_branch_creation' => 'setEnableGitBranchCreation',
        'enable_swarm_reviews' => 'setEnableSwarmReviews',
        'enable_git_merge_commits' => 'setEnableGitMergeCommits',
        'enable_git_submodules' => 'setEnableGitSubmodules',
        'ignore_author_permissions' => 'setIgnoreAuthorPermissions',
        'preflight_commit' => 'setPreflightCommit',
        'read_permission_check' => 'setReadPermissionCheck',
        'git_merge_avoidance_after_change_num' => 'setGitMergeAvoidanceAfterChangeNum',
        'job_lookup' => 'setJobLookup',
        'depot_branch_creation_enable' => 'setDepotBranchCreationEnable',
        'depot_branch_creation_p4group' => 'setDepotBranchCreationP4group',
        'depot_branch_creation_depot_path' => 'setDepotBranchCreationDepotPath',
        'depot_branch_creation_view' => 'setDepotBranchCreationView',
        'enable_git_find_copies' => 'setEnableGitFindCopies',
        'enable_git_find_renames' => 'setEnableGitFindRenames',
        'enable_stream_imports' => 'setEnableStreamImports',
        'http_url' => 'setHttpUrl',
        'ssh_url' => 'setSshUrl',
        'email_case_sensitivity' => 'setEmailCaseSensitivity',
        'author_source' => 'setAuthorSource',
        'limit_space_mb' => 'setLimitSpaceMb',
        'limit_commits_received' => 'setLimitCommitsReceived',
        'limit_files_received' => 'setLimitFilesReceived',
        'limit_megabytes_received' => 'setLimitMegabytesReceived'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'charset' => 'getCharset',
        'depot_path_repo_creation_enable' => 'getDepotPathRepoCreationEnable',
        'depot_path_repo_creation_p4group' => 'getDepotPathRepoCreationP4group',
        'change_owner' => 'getChangeOwner',
        'enable_git_branch_creation' => 'getEnableGitBranchCreation',
        'enable_swarm_reviews' => 'getEnableSwarmReviews',
        'enable_git_merge_commits' => 'getEnableGitMergeCommits',
        'enable_git_submodules' => 'getEnableGitSubmodules',
        'ignore_author_permissions' => 'getIgnoreAuthorPermissions',
        'preflight_commit' => 'getPreflightCommit',
        'read_permission_check' => 'getReadPermissionCheck',
        'git_merge_avoidance_after_change_num' => 'getGitMergeAvoidanceAfterChangeNum',
        'job_lookup' => 'getJobLookup',
        'depot_branch_creation_enable' => 'getDepotBranchCreationEnable',
        'depot_branch_creation_p4group' => 'getDepotBranchCreationP4group',
        'depot_branch_creation_depot_path' => 'getDepotBranchCreationDepotPath',
        'depot_branch_creation_view' => 'getDepotBranchCreationView',
        'enable_git_find_copies' => 'getEnableGitFindCopies',
        'enable_git_find_renames' => 'getEnableGitFindRenames',
        'enable_stream_imports' => 'getEnableStreamImports',
        'http_url' => 'getHttpUrl',
        'ssh_url' => 'getSshUrl',
        'email_case_sensitivity' => 'getEmailCaseSensitivity',
        'author_source' => 'getAuthorSource',
        'limit_space_mb' => 'getLimitSpaceMb',
        'limit_commits_received' => 'getLimitCommitsReceived',
        'limit_files_received' => 'getLimitFilesReceived',
        'limit_megabytes_received' => 'getLimitMegabytesReceived'
    );

    
    /**
      * $charset Defines the default Unicode setting that Git Fusion applies to new repos.\nThis setting is valid only when Git Fusion interacts with a Unicode-enabled Perforce server.\n\n(Defaults to `UTF-8`).
      * @var string
      */
    protected $charset;
    
    /**
      * $depot_path_repo_creation_enable Allow Git users to create new repos by pushing/pulling a git url which specifies a Perforce depot path.\nThis is similar to creating a repo from a p4 client.
      * @var string
      */
    protected $depot_path_repo_creation_enable;
    
    /**
      * $depot_path_repo_creation_p4group Restrict which authenticated Git pushers are allowed to create new repos when depot-path-repo-creation-enable is enabled.
      * @var string
      */
    protected $depot_path_repo_creation_p4group;
    
    /**
      * $change_owner Defines whether Git Fusion assigns either the Git commit author or the Git pusher as the owner of a pushed change (submit).
      * @var string
      */
    protected $change_owner;
    
    /**
      * $enable_git_branch_creation Defines whether Git Fusion creates a new branch of Perforce depot file hierarchy for each copied branch of Git workspace history, including Git task branches as Git Fusion anonymous branches.
      * @var string
      */
    protected $enable_git_branch_creation;
    
    /**
      * $enable_swarm_reviews Permits branch creation for Swarm reviews, even when enable-git-branch-creation is disabled.
      * @var string
      */
    protected $enable_swarm_reviews;
    
    /**
      * $enable_git_merge_commits Defines whether Git Fusion copies merge commits and displays them in Perforce as integrations between Perforce branches.
      * @var string
      */
    protected $enable_git_merge_commits;
    
    /**
      * $enable_git_submodules Defines whether Git Fusion allows Git submodules to be pushed to Perforce.
      * @var string
      */
    protected $enable_git_submodules;
    
    /**
      * $ignore_author_permissions Defines whether Git Fusion evaluates both the author's and pusher's Perforce write permissions during a push or evaluates only the pusher's permissions.
      * @var string
      */
    protected $ignore_author_permissions;
    
    /**
      * $preflight_commit Enables you to trigger pre-flight commit scripts that enforce local policy for Git pushes. This can be especially useful if you have Perforce submit triggers that could reject a push and damage the repository.
      * @var string
      */
    protected $preflight_commit;
    
    /**
      * $read_permission_check Enables you to require that Git clone, pull, or fetch requests check the Perforce protections table for the puller's read permission on the files being pulled.
      * @var string
      */
    protected $read_permission_check;
    
    /**
      * $git_merge_avoidance_after_change_num If the Perforce service includes any changelists submitted by Git Fusion 13.2 or earlier, you can prevent unnecessary merge commits by setting this key to the number of the last changelist submitted before your site upgraded to a later version of Git Fusion.
      * @var string
      */
    protected $git_merge_avoidance_after_change_num;
    
    /**
      * $job_lookup Set the format for entering Perforce jobs in Git commit descriptions so that they are recognized by Git Fusion and appear in Perforce changelists as fixes.\nBy default, job IDs whose string starts with \"job\" (as in job123456) are passed through to the changelist description and job field.\nUse this option if you want Git Fusion to recognize additional expressions, such as JIRA issue IDs.
      * @var string
      */
    protected $job_lookup;
    
    /**
      * $depot_branch_creation_enable Allow Git users to create new fully-populated depot branches within Perforce.
      * @var string
      */
    protected $depot_branch_creation_enable;
    
    /**
      * $depot_branch_creation_p4group Restrict the authenticated Git pushers who are allowed to create new fully-populated depot branches, if depotBranchCreationEnable is enabled.
      * @var string
      */
    protected $depot_branch_creation_p4group;
    
    /**
      * $depot_branch_creation_depot_path Tell Git Fusion where to create new fully-populated depot branches, if depotBranchCreationEnable is enabled.\n\nDefault path is `//depot/[repo]/[git_branch_name]`.
      * @var string
      */
    protected $depot_branch_creation_depot_path;
    
    /**
      * $depot_branch_creation_view Set how the depot path set in depotBranchCreationDepotPath should appear in Git.\n\nEnter a Perforce view specification that maps Perforce depot paths (left side) to Git work tree paths (right side).\nPerforce depot paths are relative to the root set in depotBranchCreationDepotPath.\n\nThe default `... ...` maps every file under the depotBranchCreationDepotPath root to Git.\nRight side paths must match the right side for every other branch already defined within a repo.
      * @var string
      */
    protected $depot_branch_creation_view;
    
    /**
      * $enable_git_find_copies When Git reports a copy file action, store that action in Perforce as a p4 integ.\nOften set in tandem with enableGitFindRenames.\n\nNo/Off/0%: Do not use Git's copy detection.\nTreat all possible file copy actions as p4 add actions.\n\n1%-100%: Use Git's copy detection. Value passed to git diff-tree --find-copies=n.\n\nGit Fusion also adds --find-copies-harder whenever adding --find-copies.
      * @var string
      */
    protected $enable_git_find_copies;
    
    /**
      * $enable_git_find_renames When Git reports a rename (also called move) file action, store that in Perforce as a p4 move.\nOften set in tandem with enableGitFindCopies.\n\n`No`/`Off`/`0%`: Do not use Git's rename detection.\nTreat all possible file rename actions as independent p4 delete and p4 add actions.\n\n`1%`-`100%`: Use Git's rename detection.\nValue passed to git diff-tree --find-renames=n.
      * @var string
      */
    protected $enable_git_find_renames;
    
    /**
      * $enable_stream_imports Enables you to convert Perforce stream import paths to Git submodules when you clone a Git Fusion repository.\nIf set to Yes, you must also set either httpUrl or sshUrl.
      * @var string
      */
    protected $enable_stream_imports;
    
    /**
      * $http_url The URL used by Git to clone a repository from Git Fusion over HTTP.\nThis property is required if you want to use Perforce stream import paths as git submodules and you use HTTP(S).
      * @var string
      */
    protected $http_url;
    
    /**
      * $ssh_url The \"URL\" used by Git to clone a repository from Git Fusion using SSH.\nThis property is required if you want to use Perforce stream import paths as git submodules and you use SSH.
      * @var string
      */
    protected $ssh_url;
    
    /**
      * $email_case_sensitivity Defines whether Git Fusion pays attention to case when matching Git user email addresses to Perforce user account email addresses during the authorization check.
      * @var string
      */
    protected $email_case_sensitivity;
    
    /**
      * $author_source Defines the source that Git Fusion uses to identify the Perforce user associated with a Git push.\n\nDefaults to `git-email`.\n\nUse any one of the following values:\n\n- `git-email`: Use the email address of the Git author to look for a Perforce user account with the same email address. Git Fusion consults the p4gf_usermap file first, and if that fails to produce a match, it scans the Perforce user table.\n- `git-user`: Use the user.name field in the Git commit. This is the part of the author field before the email address.\n- `git-email-account`: Use the account portion of the Git author's email address. If the Git author's email value is `samwise@the_shire.com`, Git Fusion uses the Perforce account samwise.\n\nYou can also tell Git Fusion to iterate through multiple source types until it finds a matching Perforce account. Specify the source types in order of precedence, separated by commas. For example: git-user, git-email-account, git-email.
      * @var string
      */
    protected $author_source;
    
    /**
      * $limit_space_mb Natural number representing the number of megabytes of disk space that can be consumed by any single repo.\nThis value does not include the spaced consumed on the Perforce server.
      * @var string
      */
    protected $limit_space_mb;
    
    /**
      * $limit_commits_received Natural number representing the maximum number of commits allowed in a single push.
      * @var string
      */
    protected $limit_commits_received;
    
    /**
      * $limit_files_received Natural number representing the maximum number of files allowed in a single push.
      * @var string
      */
    protected $limit_files_received;
    
    /**
      * $limit_megabytes_received Natural number representing the maximum number of megabytes allowed in a single push.
      * @var string
      */
    protected $limit_megabytes_received;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["charset"])) {
              $this->charset = $data["charset"];
            }
            if (isset($data["depot_path_repo_creation_enable"])) {
              $this->depot_path_repo_creation_enable = $data["depot_path_repo_creation_enable"];
            }
            if (isset($data["depot_path_repo_creation_p4group"])) {
              $this->depot_path_repo_creation_p4group = $data["depot_path_repo_creation_p4group"];
            }
            if (isset($data["change_owner"])) {
              $this->change_owner = $data["change_owner"];
            }
            if (isset($data["enable_git_branch_creation"])) {
              $this->enable_git_branch_creation = $data["enable_git_branch_creation"];
            }
            if (isset($data["enable_swarm_reviews"])) {
              $this->enable_swarm_reviews = $data["enable_swarm_reviews"];
            }
            if (isset($data["enable_git_merge_commits"])) {
              $this->enable_git_merge_commits = $data["enable_git_merge_commits"];
            }
            if (isset($data["enable_git_submodules"])) {
              $this->enable_git_submodules = $data["enable_git_submodules"];
            }
            if (isset($data["ignore_author_permissions"])) {
              $this->ignore_author_permissions = $data["ignore_author_permissions"];
            }
            if (isset($data["preflight_commit"])) {
              $this->preflight_commit = $data["preflight_commit"];
            }
            if (isset($data["read_permission_check"])) {
              $this->read_permission_check = $data["read_permission_check"];
            }
            if (isset($data["git_merge_avoidance_after_change_num"])) {
              $this->git_merge_avoidance_after_change_num = $data["git_merge_avoidance_after_change_num"];
            }
            if (isset($data["job_lookup"])) {
              $this->job_lookup = $data["job_lookup"];
            }
            if (isset($data["depot_branch_creation_enable"])) {
              $this->depot_branch_creation_enable = $data["depot_branch_creation_enable"];
            }
            if (isset($data["depot_branch_creation_p4group"])) {
              $this->depot_branch_creation_p4group = $data["depot_branch_creation_p4group"];
            }
            if (isset($data["depot_branch_creation_depot_path"])) {
              $this->depot_branch_creation_depot_path = $data["depot_branch_creation_depot_path"];
            }
            if (isset($data["depot_branch_creation_view"])) {
              $this->depot_branch_creation_view = $data["depot_branch_creation_view"];
            }
            if (isset($data["enable_git_find_copies"])) {
              $this->enable_git_find_copies = $data["enable_git_find_copies"];
            }
            if (isset($data["enable_git_find_renames"])) {
              $this->enable_git_find_renames = $data["enable_git_find_renames"];
            }
            if (isset($data["enable_stream_imports"])) {
              $this->enable_stream_imports = $data["enable_stream_imports"];
            }
            if (isset($data["http_url"])) {
              $this->http_url = $data["http_url"];
            }
            if (isset($data["ssh_url"])) {
              $this->ssh_url = $data["ssh_url"];
            }
            if (isset($data["email_case_sensitivity"])) {
              $this->email_case_sensitivity = $data["email_case_sensitivity"];
            }
            if (isset($data["author_source"])) {
              $this->author_source = $data["author_source"];
            }
            if (isset($data["limit_space_mb"])) {
              $this->limit_space_mb = $data["limit_space_mb"];
            }
            if (isset($data["limit_commits_received"])) {
              $this->limit_commits_received = $data["limit_commits_received"];
            }
            if (isset($data["limit_files_received"])) {
              $this->limit_files_received = $data["limit_files_received"];
            }
            if (isset($data["limit_megabytes_received"])) {
              $this->limit_megabytes_received = $data["limit_megabytes_received"];
            }
        }
    }
    
    /**
     * Gets charset
     * @return string
     */
    public function getCharset()
    {
        return $this->charset;
    }

    /**
     * Sets charset
     * @param string $charset Defines the default Unicode setting that Git Fusion applies to new repos.\nThis setting is valid only when Git Fusion interacts with a Unicode-enabled Perforce server.\n\n(Defaults to `UTF-8`).
     * @return $this
     */
    public function setCharset($charset)
    {
        
        $this->charset = $charset;
        return $this;
    }
    
    /**
     * Gets depot_path_repo_creation_enable
     * @return string
     */
    public function getDepotPathRepoCreationEnable()
    {
        return $this->depot_path_repo_creation_enable;
    }

    /**
     * Sets depot_path_repo_creation_enable
     * @param string $depot_path_repo_creation_enable Allow Git users to create new repos by pushing/pulling a git url which specifies a Perforce depot path.\nThis is similar to creating a repo from a p4 client.
     * @return $this
     */
    public function setDepotPathRepoCreationEnable($depot_path_repo_creation_enable)
    {
        
        $this->depot_path_repo_creation_enable = $depot_path_repo_creation_enable;
        return $this;
    }
    
    /**
     * Gets depot_path_repo_creation_p4group
     * @return string
     */
    public function getDepotPathRepoCreationP4group()
    {
        return $this->depot_path_repo_creation_p4group;
    }

    /**
     * Sets depot_path_repo_creation_p4group
     * @param string $depot_path_repo_creation_p4group Restrict which authenticated Git pushers are allowed to create new repos when depot-path-repo-creation-enable is enabled.
     * @return $this
     */
    public function setDepotPathRepoCreationP4group($depot_path_repo_creation_p4group)
    {
        
        $this->depot_path_repo_creation_p4group = $depot_path_repo_creation_p4group;
        return $this;
    }
    
    /**
     * Gets change_owner
     * @return string
     */
    public function getChangeOwner()
    {
        return $this->change_owner;
    }

    /**
     * Sets change_owner
     * @param string $change_owner Defines whether Git Fusion assigns either the Git commit author or the Git pusher as the owner of a pushed change (submit).
     * @return $this
     */
    public function setChangeOwner($change_owner)
    {
        
        $this->change_owner = $change_owner;
        return $this;
    }
    
    /**
     * Gets enable_git_branch_creation
     * @return string
     */
    public function getEnableGitBranchCreation()
    {
        return $this->enable_git_branch_creation;
    }

    /**
     * Sets enable_git_branch_creation
     * @param string $enable_git_branch_creation Defines whether Git Fusion creates a new branch of Perforce depot file hierarchy for each copied branch of Git workspace history, including Git task branches as Git Fusion anonymous branches.
     * @return $this
     */
    public function setEnableGitBranchCreation($enable_git_branch_creation)
    {
        
        $this->enable_git_branch_creation = $enable_git_branch_creation;
        return $this;
    }
    
    /**
     * Gets enable_swarm_reviews
     * @return string
     */
    public function getEnableSwarmReviews()
    {
        return $this->enable_swarm_reviews;
    }

    /**
     * Sets enable_swarm_reviews
     * @param string $enable_swarm_reviews Permits branch creation for Swarm reviews, even when enable-git-branch-creation is disabled.
     * @return $this
     */
    public function setEnableSwarmReviews($enable_swarm_reviews)
    {
        
        $this->enable_swarm_reviews = $enable_swarm_reviews;
        return $this;
    }
    
    /**
     * Gets enable_git_merge_commits
     * @return string
     */
    public function getEnableGitMergeCommits()
    {
        return $this->enable_git_merge_commits;
    }

    /**
     * Sets enable_git_merge_commits
     * @param string $enable_git_merge_commits Defines whether Git Fusion copies merge commits and displays them in Perforce as integrations between Perforce branches.
     * @return $this
     */
    public function setEnableGitMergeCommits($enable_git_merge_commits)
    {
        
        $this->enable_git_merge_commits = $enable_git_merge_commits;
        return $this;
    }
    
    /**
     * Gets enable_git_submodules
     * @return string
     */
    public function getEnableGitSubmodules()
    {
        return $this->enable_git_submodules;
    }

    /**
     * Sets enable_git_submodules
     * @param string $enable_git_submodules Defines whether Git Fusion allows Git submodules to be pushed to Perforce.
     * @return $this
     */
    public function setEnableGitSubmodules($enable_git_submodules)
    {
        
        $this->enable_git_submodules = $enable_git_submodules;
        return $this;
    }
    
    /**
     * Gets ignore_author_permissions
     * @return string
     */
    public function getIgnoreAuthorPermissions()
    {
        return $this->ignore_author_permissions;
    }

    /**
     * Sets ignore_author_permissions
     * @param string $ignore_author_permissions Defines whether Git Fusion evaluates both the author's and pusher's Perforce write permissions during a push or evaluates only the pusher's permissions.
     * @return $this
     */
    public function setIgnoreAuthorPermissions($ignore_author_permissions)
    {
        
        $this->ignore_author_permissions = $ignore_author_permissions;
        return $this;
    }
    
    /**
     * Gets preflight_commit
     * @return string
     */
    public function getPreflightCommit()
    {
        return $this->preflight_commit;
    }

    /**
     * Sets preflight_commit
     * @param string $preflight_commit Enables you to trigger pre-flight commit scripts that enforce local policy for Git pushes. This can be especially useful if you have Perforce submit triggers that could reject a push and damage the repository.
     * @return $this
     */
    public function setPreflightCommit($preflight_commit)
    {
        
        $this->preflight_commit = $preflight_commit;
        return $this;
    }
    
    /**
     * Gets read_permission_check
     * @return string
     */
    public function getReadPermissionCheck()
    {
        return $this->read_permission_check;
    }

    /**
     * Sets read_permission_check
     * @param string $read_permission_check Enables you to require that Git clone, pull, or fetch requests check the Perforce protections table for the puller's read permission on the files being pulled.
     * @return $this
     */
    public function setReadPermissionCheck($read_permission_check)
    {
        
        $this->read_permission_check = $read_permission_check;
        return $this;
    }
    
    /**
     * Gets git_merge_avoidance_after_change_num
     * @return string
     */
    public function getGitMergeAvoidanceAfterChangeNum()
    {
        return $this->git_merge_avoidance_after_change_num;
    }

    /**
     * Sets git_merge_avoidance_after_change_num
     * @param string $git_merge_avoidance_after_change_num If the Perforce service includes any changelists submitted by Git Fusion 13.2 or earlier, you can prevent unnecessary merge commits by setting this key to the number of the last changelist submitted before your site upgraded to a later version of Git Fusion.
     * @return $this
     */
    public function setGitMergeAvoidanceAfterChangeNum($git_merge_avoidance_after_change_num)
    {
        
        $this->git_merge_avoidance_after_change_num = $git_merge_avoidance_after_change_num;
        return $this;
    }
    
    /**
     * Gets job_lookup
     * @return string
     */
    public function getJobLookup()
    {
        return $this->job_lookup;
    }

    /**
     * Sets job_lookup
     * @param string $job_lookup Set the format for entering Perforce jobs in Git commit descriptions so that they are recognized by Git Fusion and appear in Perforce changelists as fixes.\nBy default, job IDs whose string starts with \"job\" (as in job123456) are passed through to the changelist description and job field.\nUse this option if you want Git Fusion to recognize additional expressions, such as JIRA issue IDs.
     * @return $this
     */
    public function setJobLookup($job_lookup)
    {
        
        $this->job_lookup = $job_lookup;
        return $this;
    }
    
    /**
     * Gets depot_branch_creation_enable
     * @return string
     */
    public function getDepotBranchCreationEnable()
    {
        return $this->depot_branch_creation_enable;
    }

    /**
     * Sets depot_branch_creation_enable
     * @param string $depot_branch_creation_enable Allow Git users to create new fully-populated depot branches within Perforce.
     * @return $this
     */
    public function setDepotBranchCreationEnable($depot_branch_creation_enable)
    {
        
        $this->depot_branch_creation_enable = $depot_branch_creation_enable;
        return $this;
    }
    
    /**
     * Gets depot_branch_creation_p4group
     * @return string
     */
    public function getDepotBranchCreationP4group()
    {
        return $this->depot_branch_creation_p4group;
    }

    /**
     * Sets depot_branch_creation_p4group
     * @param string $depot_branch_creation_p4group Restrict the authenticated Git pushers who are allowed to create new fully-populated depot branches, if depotBranchCreationEnable is enabled.
     * @return $this
     */
    public function setDepotBranchCreationP4group($depot_branch_creation_p4group)
    {
        
        $this->depot_branch_creation_p4group = $depot_branch_creation_p4group;
        return $this;
    }
    
    /**
     * Gets depot_branch_creation_depot_path
     * @return string
     */
    public function getDepotBranchCreationDepotPath()
    {
        return $this->depot_branch_creation_depot_path;
    }

    /**
     * Sets depot_branch_creation_depot_path
     * @param string $depot_branch_creation_depot_path Tell Git Fusion where to create new fully-populated depot branches, if depotBranchCreationEnable is enabled.\n\nDefault path is `//depot/[repo]/[git_branch_name]`.
     * @return $this
     */
    public function setDepotBranchCreationDepotPath($depot_branch_creation_depot_path)
    {
        
        $this->depot_branch_creation_depot_path = $depot_branch_creation_depot_path;
        return $this;
    }
    
    /**
     * Gets depot_branch_creation_view
     * @return string
     */
    public function getDepotBranchCreationView()
    {
        return $this->depot_branch_creation_view;
    }

    /**
     * Sets depot_branch_creation_view
     * @param string $depot_branch_creation_view Set how the depot path set in depotBranchCreationDepotPath should appear in Git.\n\nEnter a Perforce view specification that maps Perforce depot paths (left side) to Git work tree paths (right side).\nPerforce depot paths are relative to the root set in depotBranchCreationDepotPath.\n\nThe default `... ...` maps every file under the depotBranchCreationDepotPath root to Git.\nRight side paths must match the right side for every other branch already defined within a repo.
     * @return $this
     */
    public function setDepotBranchCreationView($depot_branch_creation_view)
    {
        
        $this->depot_branch_creation_view = $depot_branch_creation_view;
        return $this;
    }
    
    /**
     * Gets enable_git_find_copies
     * @return string
     */
    public function getEnableGitFindCopies()
    {
        return $this->enable_git_find_copies;
    }

    /**
     * Sets enable_git_find_copies
     * @param string $enable_git_find_copies When Git reports a copy file action, store that action in Perforce as a p4 integ.\nOften set in tandem with enableGitFindRenames.\n\nNo/Off/0%: Do not use Git's copy detection.\nTreat all possible file copy actions as p4 add actions.\n\n1%-100%: Use Git's copy detection. Value passed to git diff-tree --find-copies=n.\n\nGit Fusion also adds --find-copies-harder whenever adding --find-copies.
     * @return $this
     */
    public function setEnableGitFindCopies($enable_git_find_copies)
    {
        
        $this->enable_git_find_copies = $enable_git_find_copies;
        return $this;
    }
    
    /**
     * Gets enable_git_find_renames
     * @return string
     */
    public function getEnableGitFindRenames()
    {
        return $this->enable_git_find_renames;
    }

    /**
     * Sets enable_git_find_renames
     * @param string $enable_git_find_renames When Git reports a rename (also called move) file action, store that in Perforce as a p4 move.\nOften set in tandem with enableGitFindCopies.\n\n`No`/`Off`/`0%`: Do not use Git's rename detection.\nTreat all possible file rename actions as independent p4 delete and p4 add actions.\n\n`1%`-`100%`: Use Git's rename detection.\nValue passed to git diff-tree --find-renames=n.
     * @return $this
     */
    public function setEnableGitFindRenames($enable_git_find_renames)
    {
        
        $this->enable_git_find_renames = $enable_git_find_renames;
        return $this;
    }
    
    /**
     * Gets enable_stream_imports
     * @return string
     */
    public function getEnableStreamImports()
    {
        return $this->enable_stream_imports;
    }

    /**
     * Sets enable_stream_imports
     * @param string $enable_stream_imports Enables you to convert Perforce stream import paths to Git submodules when you clone a Git Fusion repository.\nIf set to Yes, you must also set either httpUrl or sshUrl.
     * @return $this
     */
    public function setEnableStreamImports($enable_stream_imports)
    {
        
        $this->enable_stream_imports = $enable_stream_imports;
        return $this;
    }
    
    /**
     * Gets http_url
     * @return string
     */
    public function getHttpUrl()
    {
        return $this->http_url;
    }

    /**
     * Sets http_url
     * @param string $http_url The URL used by Git to clone a repository from Git Fusion over HTTP.\nThis property is required if you want to use Perforce stream import paths as git submodules and you use HTTP(S).
     * @return $this
     */
    public function setHttpUrl($http_url)
    {
        
        $this->http_url = $http_url;
        return $this;
    }
    
    /**
     * Gets ssh_url
     * @return string
     */
    public function getSshUrl()
    {
        return $this->ssh_url;
    }

    /**
     * Sets ssh_url
     * @param string $ssh_url The \"URL\" used by Git to clone a repository from Git Fusion using SSH.\nThis property is required if you want to use Perforce stream import paths as git submodules and you use SSH.
     * @return $this
     */
    public function setSshUrl($ssh_url)
    {
        
        $this->ssh_url = $ssh_url;
        return $this;
    }
    
    /**
     * Gets email_case_sensitivity
     * @return string
     */
    public function getEmailCaseSensitivity()
    {
        return $this->email_case_sensitivity;
    }

    /**
     * Sets email_case_sensitivity
     * @param string $email_case_sensitivity Defines whether Git Fusion pays attention to case when matching Git user email addresses to Perforce user account email addresses during the authorization check.
     * @return $this
     */
    public function setEmailCaseSensitivity($email_case_sensitivity)
    {
        
        $this->email_case_sensitivity = $email_case_sensitivity;
        return $this;
    }
    
    /**
     * Gets author_source
     * @return string
     */
    public function getAuthorSource()
    {
        return $this->author_source;
    }

    /**
     * Sets author_source
     * @param string $author_source Defines the source that Git Fusion uses to identify the Perforce user associated with a Git push.\n\nDefaults to `git-email`.\n\nUse any one of the following values:\n\n- `git-email`: Use the email address of the Git author to look for a Perforce user account with the same email address. Git Fusion consults the p4gf_usermap file first, and if that fails to produce a match, it scans the Perforce user table.\n- `git-user`: Use the user.name field in the Git commit. This is the part of the author field before the email address.\n- `git-email-account`: Use the account portion of the Git author's email address. If the Git author's email value is `samwise@the_shire.com`, Git Fusion uses the Perforce account samwise.\n\nYou can also tell Git Fusion to iterate through multiple source types until it finds a matching Perforce account. Specify the source types in order of precedence, separated by commas. For example: git-user, git-email-account, git-email.
     * @return $this
     */
    public function setAuthorSource($author_source)
    {
        
        $this->author_source = $author_source;
        return $this;
    }
    
    /**
     * Gets limit_space_mb
     * @return string
     */
    public function getLimitSpaceMb()
    {
        return $this->limit_space_mb;
    }

    /**
     * Sets limit_space_mb
     * @param string $limit_space_mb Natural number representing the number of megabytes of disk space that can be consumed by any single repo.\nThis value does not include the spaced consumed on the Perforce server.
     * @return $this
     */
    public function setLimitSpaceMb($limit_space_mb)
    {
        
        $this->limit_space_mb = $limit_space_mb;
        return $this;
    }
    
    /**
     * Gets limit_commits_received
     * @return string
     */
    public function getLimitCommitsReceived()
    {
        return $this->limit_commits_received;
    }

    /**
     * Sets limit_commits_received
     * @param string $limit_commits_received Natural number representing the maximum number of commits allowed in a single push.
     * @return $this
     */
    public function setLimitCommitsReceived($limit_commits_received)
    {
        
        $this->limit_commits_received = $limit_commits_received;
        return $this;
    }
    
    /**
     * Gets limit_files_received
     * @return string
     */
    public function getLimitFilesReceived()
    {
        return $this->limit_files_received;
    }

    /**
     * Sets limit_files_received
     * @param string $limit_files_received Natural number representing the maximum number of files allowed in a single push.
     * @return $this
     */
    public function setLimitFilesReceived($limit_files_received)
    {
        
        $this->limit_files_received = $limit_files_received;
        return $this;
    }
    
    /**
     * Gets limit_megabytes_received
     * @return string
     */
    public function getLimitMegabytesReceived()
    {
        return $this->limit_megabytes_received;
    }

    /**
     * Sets limit_megabytes_received
     * @param string $limit_megabytes_received Natural number representing the maximum number of megabytes allowed in a single push.
     * @return $this
     */
    public function setLimitMegabytesReceived($limit_megabytes_received)
    {
        
        $this->limit_megabytes_received = $limit_megabytes_received;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
