<?php
/**
 * GroupsCommand
 *
 * PHP version 5
 *
 * @category Class
 * @package  HelixWebServices
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2015 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace HelixWebServices\Model;

use \ArrayAccess;
/**
 * GroupsCommand Class Doc Comment
 *
 * @category    Class
 * @description A list of entries that can show the layout how users are associated with the different groups in the system.
 * @package     HelixWebServices
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class GroupsCommand implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    static $swaggerTypes = array(
        'user' => 'string',
        'group' => 'string',
        'is_sub_group' => 'string',
        'is_owner' => 'string',
        'is_user' => 'string',
        'max_results' => 'string',
        'max_scan_rows' => 'string',
        'max_lock_time' => 'string',
        'max_open_files' => 'string',
        'timeout' => 'string',
        'pass_timeout' => 'string'
    );

    /**
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[]
      */
    static $attributeMap = array(
        'user' => 'user',
        'group' => 'group',
        'is_sub_group' => 'isSubGroup',
        'is_owner' => 'isOwner',
        'is_user' => 'isUser',
        'max_results' => 'maxResults',
        'max_scan_rows' => 'maxScanRows',
        'max_lock_time' => 'maxLockTime',
        'max_open_files' => 'maxOpenFiles',
        'timeout' => 'timeout',
        'pass_timeout' => 'passTimeout'
    );

    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'user' => 'setUser',
        'group' => 'setGroup',
        'is_sub_group' => 'setIsSubGroup',
        'is_owner' => 'setIsOwner',
        'is_user' => 'setIsUser',
        'max_results' => 'setMaxResults',
        'max_scan_rows' => 'setMaxScanRows',
        'max_lock_time' => 'setMaxLockTime',
        'max_open_files' => 'setMaxOpenFiles',
        'timeout' => 'setTimeout',
        'pass_timeout' => 'setPassTimeout'
    );

    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'user' => 'getUser',
        'group' => 'getGroup',
        'is_sub_group' => 'getIsSubGroup',
        'is_owner' => 'getIsOwner',
        'is_user' => 'getIsUser',
        'max_results' => 'getMaxResults',
        'max_scan_rows' => 'getMaxScanRows',
        'max_lock_time' => 'getMaxLockTime',
        'max_open_files' => 'getMaxOpenFiles',
        'timeout' => 'getTimeout',
        'pass_timeout' => 'getPassTimeout'
    );

    
    /**
      * $user 
      * @var string
      */
    protected $user;
    
    /**
      * $group 
      * @var string
      */
    protected $group;
    
    /**
      * $is_sub_group 
      * @var string
      */
    protected $is_sub_group;
    
    /**
      * $is_owner 
      * @var string
      */
    protected $is_owner;
    
    /**
      * $is_user 
      * @var string
      */
    protected $is_user;
    
    /**
      * $max_results 
      * @var string
      */
    protected $max_results;
    
    /**
      * $max_scan_rows 
      * @var string
      */
    protected $max_scan_rows;
    
    /**
      * $max_lock_time 
      * @var string
      */
    protected $max_lock_time;
    
    /**
      * $max_open_files 
      * @var string
      */
    protected $max_open_files;
    
    /**
      * $timeout 
      * @var string
      */
    protected $timeout;
    
    /**
      * $pass_timeout 
      * @var string
      */
    protected $pass_timeout;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            if (isset($data["user"])) {
              $this->user = $data["user"];
            }
            if (isset($data["group"])) {
              $this->group = $data["group"];
            }
            if (isset($data["is_sub_group"])) {
              $this->is_sub_group = $data["is_sub_group"];
            }
            if (isset($data["is_owner"])) {
              $this->is_owner = $data["is_owner"];
            }
            if (isset($data["is_user"])) {
              $this->is_user = $data["is_user"];
            }
            if (isset($data["max_results"])) {
              $this->max_results = $data["max_results"];
            }
            if (isset($data["max_scan_rows"])) {
              $this->max_scan_rows = $data["max_scan_rows"];
            }
            if (isset($data["max_lock_time"])) {
              $this->max_lock_time = $data["max_lock_time"];
            }
            if (isset($data["max_open_files"])) {
              $this->max_open_files = $data["max_open_files"];
            }
            if (isset($data["timeout"])) {
              $this->timeout = $data["timeout"];
            }
            if (isset($data["pass_timeout"])) {
              $this->pass_timeout = $data["pass_timeout"];
            }
        }
    }
    
    /**
     * Gets user
     * @return string
     */
    public function getUser()
    {
        return $this->user;
    }

    /**
     * Sets user
     * @param string $user 
     * @return $this
     */
    public function setUser($user)
    {
        
        $this->user = $user;
        return $this;
    }
    
    /**
     * Gets group
     * @return string
     */
    public function getGroup()
    {
        return $this->group;
    }

    /**
     * Sets group
     * @param string $group 
     * @return $this
     */
    public function setGroup($group)
    {
        
        $this->group = $group;
        return $this;
    }
    
    /**
     * Gets is_sub_group
     * @return string
     */
    public function getIsSubGroup()
    {
        return $this->is_sub_group;
    }

    /**
     * Sets is_sub_group
     * @param string $is_sub_group 
     * @return $this
     */
    public function setIsSubGroup($is_sub_group)
    {
        
        $this->is_sub_group = $is_sub_group;
        return $this;
    }
    
    /**
     * Gets is_owner
     * @return string
     */
    public function getIsOwner()
    {
        return $this->is_owner;
    }

    /**
     * Sets is_owner
     * @param string $is_owner 
     * @return $this
     */
    public function setIsOwner($is_owner)
    {
        
        $this->is_owner = $is_owner;
        return $this;
    }
    
    /**
     * Gets is_user
     * @return string
     */
    public function getIsUser()
    {
        return $this->is_user;
    }

    /**
     * Sets is_user
     * @param string $is_user 
     * @return $this
     */
    public function setIsUser($is_user)
    {
        
        $this->is_user = $is_user;
        return $this;
    }
    
    /**
     * Gets max_results
     * @return string
     */
    public function getMaxResults()
    {
        return $this->max_results;
    }

    /**
     * Sets max_results
     * @param string $max_results 
     * @return $this
     */
    public function setMaxResults($max_results)
    {
        
        $this->max_results = $max_results;
        return $this;
    }
    
    /**
     * Gets max_scan_rows
     * @return string
     */
    public function getMaxScanRows()
    {
        return $this->max_scan_rows;
    }

    /**
     * Sets max_scan_rows
     * @param string $max_scan_rows 
     * @return $this
     */
    public function setMaxScanRows($max_scan_rows)
    {
        
        $this->max_scan_rows = $max_scan_rows;
        return $this;
    }
    
    /**
     * Gets max_lock_time
     * @return string
     */
    public function getMaxLockTime()
    {
        return $this->max_lock_time;
    }

    /**
     * Sets max_lock_time
     * @param string $max_lock_time 
     * @return $this
     */
    public function setMaxLockTime($max_lock_time)
    {
        
        $this->max_lock_time = $max_lock_time;
        return $this;
    }
    
    /**
     * Gets max_open_files
     * @return string
     */
    public function getMaxOpenFiles()
    {
        return $this->max_open_files;
    }

    /**
     * Sets max_open_files
     * @param string $max_open_files 
     * @return $this
     */
    public function setMaxOpenFiles($max_open_files)
    {
        
        $this->max_open_files = $max_open_files;
        return $this;
    }
    
    /**
     * Gets timeout
     * @return string
     */
    public function getTimeout()
    {
        return $this->timeout;
    }

    /**
     * Sets timeout
     * @param string $timeout 
     * @return $this
     */
    public function setTimeout($timeout)
    {
        
        $this->timeout = $timeout;
        return $this;
    }
    
    /**
     * Gets pass_timeout
     * @return string
     */
    public function getPassTimeout()
    {
        return $this->pass_timeout;
    }

    /**
     * Sets pass_timeout
     * @param string $pass_timeout 
     * @return $this
     */
    public function setPassTimeout($pass_timeout)
    {
        
        $this->pass_timeout = $pass_timeout;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(get_object_vars($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(get_object_vars($this));
        }
    }
}
